-- 2012/05/28 ̂dZ 

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

----------------------------------------------------------------------------------------------------

entity CmdCtrl is
port(
	Clk : in std_logic;
	
	i_bRun : in std_logic;
	
	o_1P_nL : out std_logic;
	o_1P_nD : out std_logic;
	o_1P_nR : out std_logic;
	o_1P_nU : out std_logic;
	o_1P_nG : out std_logic;
	o_1P_nP : out std_logic;
	o_1P_nK : out std_logic;
	
	o_2P_nL : out std_logic;
	o_2P_nD : out std_logic;
	o_2P_nR : out std_logic;
	o_2P_nU : out std_logic;
	o_2P_nG : out std_logic;
	o_2P_nP : out std_logic;
	o_2P_nK : out std_logic );
end entity;

----------------------------------------------------------------------------------------------------

architecture Bhv of CmdCtrl is

----------------------------------------------------------------------------------------------------
-- component
----------------------------------------------------------------------------------------------------

component CmdROM
port(
	  Clk  : in  std_logic;
	i_Addr : in  std_logic_vector( 12 downto 0 );
	o_Data : out std_logic_vector( 13 downto 0 ) );
end component;

----------------------------------------------------------------------------------------------------
-- signal
----------------------------------------------------------------------------------------------------

signal bRun : std_logic := '0';

signal CntRunBtnDwn : std_logic_vector( 20 downto 0 ) := ( others => '0' );

signal CntOneFrame : std_logic_vector( 20 downto 0 ) := ( others => '0' );

signal Addr : std_logic_vector( 12 downto 0 ) := ( others => '1' );
signal Cmds : std_logic_vector( 13 downto 0 ) := ( others => '0' );

----------------------------------------------------------------------------------------------------

begin

----------------------------------------------------------------------------------------------------
-- port map
----------------------------------------------------------------------------------------------------

cmpCmdROM : CmdROM
port map(
	  Clk  => Clk,
	i_Addr => Addr,
	o_Data => Cmds );

----------------------------------------------------------------------------------------------------
-- process
----------------------------------------------------------------------------------------------------

process( Clk )
begin
	if( rising_edge( Clk ) ) then
		
		----------------------------------------------------------------------------------------------------
		-- s{^`FbNimCY΍j
		----------------------------------------------------------------------------------------------------
		
		if( i_bRun = '1' ) then
			if( CntRunBtnDwn /= 2 ** CntRunBtnDwn'length - 1 ) then
				CntRunBtnDwn <= CntRunBtnDwn + 1;
			end if;
		else
			CntRunBtnDwn <= ( others => '0' );
		end if;
		
		if( CntRunBtnDwn = 1668337 ) then
			bRun <= '1';
		end if;
		
		----------------------------------------------------------------------------------------------------
		-- R}hs
		----------------------------------------------------------------------------------------------------
		
		if( CntOneFrame = 1668337 ) then
			CntOneFrame <= ( others => '0' );
			
			if( bRun  = '1' ) then
				bRun <= '0';
				Addr <= ( others => '0' );
			else
				if( Addr /= 2 ** Addr'length - 1 ) then
					Addr <= Addr + 1;
				end if;
			end if;
		else
			CntOneFrame <= CntOneFrame + 1;
		end if;
		
		----------------------------------------------------------------------------------------------------
		
	end if;
end process;

----------------------------------------------------------------------------------------------------
-- output
----------------------------------------------------------------------------------------------------

o_1P_nL <= not( Cmds(  0 ) );
o_1P_nD <= not( Cmds(  1 ) );
o_1P_nR <= not( Cmds(  2 ) );
o_1P_nU <= not( Cmds(  3 ) );
o_1P_nP <= not( Cmds(  4 ) );
o_1P_nK <= not( Cmds(  5 ) );
o_1P_nG <= not( Cmds(  6 ) );

o_2P_nL <= not( Cmds(  7 ) );
o_2P_nD <= not( Cmds(  8 ) );
o_2P_nR <= not( Cmds(  9 ) );
o_2P_nU <= not( Cmds( 10 ) );
o_2P_nP <= not( Cmds( 11 ) );
o_2P_nK <= not( Cmds( 12 ) );
o_2P_nG <= not( Cmds( 13 ) );

----------------------------------------------------------------------------------------------------

end architecture;
